
	AREA Tunnel, CODE, READONLY
        EXTERN tunnelbegin
        EXTERN tunnelend
        EXTERN imagebegin
        EXTERN imageend	
        EXTERN asciia
        EXTERN asciib
        EXTERN asciic

	ENTRY
	b 	start
	DCD 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 	DCD 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 	DCD 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
start
      ldr r0, =ramrun
      mov r1, #0x03000000
      add r1,r1,#0x40
      ldr r3, =endof+0x200
ho 	cmp 	r0, r3 			; Copy init data
	ldrne 	r2, [r0], #4
	strne 	r2, [r1], #4
	bne 	ho

        ldr r1,=0x03000040
     mov pc,r1    ;jump to code

ramrun
    mov r2,#0x04000000
    ldr r1,=0x00000403
    str r1,[r2]
    mov r0,#0
    mov r10,#0x02000000     ;r10 is tunnelpointer
    mov r11,#0x03000000
    add r11,r11,#0x1000     ;r11 is image pointer
    mov r12,#0x06000000     ;r12 is screen pointer
    

;    mov r0,#0
;    mov r1,#170
;    mov r2,#0x07000000
;    mov r3,#0
;oamclear
;    str r1,[r2],#4
;    str r0,[r2],#4
;    add r3,r3,#1
;    cmp r3,#128
;    bne oamclear

;    ldr r1,=asciia
;    ldr r2,=asciib
;    mov r3,#0x06000000
;    add r3,r3,#0x14000
;fontcopy    cmp r1,r2
;    ldrne r0,[r1],#4
;    strne r0,[r3],#4
;    bne fontcopy

;    ldr r1,=asciib
;    ldr r2,=asciic
;    mov r3,#0x05000000
;    add r3,r3,#512
;palcopy     cmp r1,r2
;    ldrne r0,[r1],#2
;    strne r0,[r3],#2
;    bne palcopy


    ldr r1,=tunnelbegin
    ldr r2,=tunnelend
    mov r3,r10
copytunnel  ldrh r0,[r1],#2
            strh r0,[r3],#2
            cmp  r2,r1
            bgt copytunnel

    ldr r1,=imagebegin
    ldr r2,=imageend
    mov r3,r11
copyimage   ldrh r0,[r1],#2
            strh r0,[r3],#2
            cmp r2,r1
            bgt copyimage

;    mov r1,#0x04000000
;   add r1,r1,#0x00100
;    mov r0,#0
;    strh r0,[r1,#8]
;    mov r0,#0x084
; ;   strh r0,[r1,#10]
;    mov r5,#0
    mov r8,#1
;    mov r9,#1
tunnelloop
    mov r2,r10
    mov r3,r12
    mov r4,#120*160
    ldr r9,=0x0fff
screenloop
    ldrh r0,[r2],#2         ;external ram read
    add r0,r0,r8
    and r0,r0,r9
    add r1,r11,r0,LSL #1    ;1 cycle (3 operations!!)
    ldrh r14,[r1]            ;read internal ram

    ldrh r0,[r2],#2         ;external ram read
    add r0,r0,r8
    and r0,r0,r9
    add r1,r11,r0,LSL #1    ;1 cycle (3 operations!!)
    ldrh r0,[r1]            ;read internal ram

    add r0,r14,r0,LSL #16
    str r0,[r3],#4         ;store to vram




    subs r4,r4,#1           ;1 cycle
    bne screenloop          ;1 cycle

    add r8,r8,#0x0042
    
    b tunnelloop



;    add r5,r5,#1
 ;   mov r4,#0x04000000
 ;   add r4,r4,#0x00100
 ;   ldrh r1,[r4,#8]
 ;   ldr r2,=16780000
 ;   cmp r1,r2
 ;   blt tunnelloop
 ;   
;
;
;
;    b tunnelloop
                







endof

    END